import pylab
from timeit import timeit

NUM_TRIALS = 1000

def measureTime(function, *args, number= NUM_TRIALS,**kwargs):
  if not args: 
    arguments = []

  if not kwargs:
    kwargs = {}

  return timeit(lambda: function(*args, **kwargs), number=number)

def timeTrials(function, trials, number=NUM_TRIALS):
  return [measureTime(function, trial, number=number) for trial in trials]

def timeFunctions(trials, functions, number=NUM_TRIALS):
  return [timeTrials(function, trials, number) for function in functions]

def plot(domain, ranges, legend=[]):

  # configure axes
  axes = pylab.axes()
  axes.set_xlabel('n')
  axes.spines['top'].set_color('none')
  axes.spines['right'].set_color('none')
  axes.xaxis.tick_bottom()
  axes.yaxis.tick_left()

  for r in ranges:
    axes.plot(domain, r)
  
  axes.legend(legend, loc=2) 
